=== src/tests/CMakeLists.txt ===
include(ECMAddTests)
include(ECMMarkNonGuiExecutable)

set(EXECUTABLE_OUTPUT_PATH ${CMAKE_CURRENT_BINARY_DIR})

# formattest includes fieldformat that include core/tellico_config.h
# which is generated in the build directory
include_directories(${Tellico_BINARY_DIR}/src)

ecm_add_test(entitytest.cpp ../fieldformat.cpp
    TEST_NAME entitytest
    LINK_LIBRARIES Qt${QT_MAJOR_VERSION}::Test utils config
)

ecm_add_test(comparisontest.cpp
    TEST_NAME comparisontest
    LINK_LIBRARIES Qt${QT_MAJOR_VERSION}::Test tellicotest tellicomodels
)

ecm_add_test(completiontest.cpp ../fieldcompletion.cpp ../field.cpp ../fieldformat.cpp
    TEST_NAME completiontest
    LINK_LIBRARIES Qt${QT_MAJOR_VERSION}::Test KF${KF_MAJOR_VERSION}::Completion utils config
)

ecm_add_test(cuecattest.cpp
    TEST_NAME cuecattest
    LINK_LIBRARIES Qt${QT_MAJOR_VERSION}::Test utils
)

ecm_add_test(isbntest.cpp
    TEST_NAME isbntest
    LINK_LIBRARIES Qt${QT_MAJOR_VERSION}::Test utils
)

ecm_add_test(lccntest.cpp
    TEST_NAME lccntest
    LINK_LIBRARIES Qt${QT_MAJOR_VERSION}::Test utils
)

ecm_add_test(lcctest.cpp ../field.cpp ../fieldformat.cpp ../tellico_debug.cpp
    TEST_NAME lcctest
    LINK_LIBRARIES Qt${QT_MAJOR_VERSION}::Test tellicomodels
)

ecm_add_test(formattest.cpp ../fieldformat.cpp
    TEST_NAME formattest
    LINK_LIBRARIES Qt${QT_MAJOR_VERSION}::Test config
)

ecm_add_test(fieldtest.cpp ../field.cpp ../fieldformat.cpp
    TEST_NAME fieldtest
    LINK_LIBRARIES Qt${QT_MAJOR_VERSION}::Test config utils
)

ecm_add_test(imagetest.cpp
             ../utils/tellico_utils.cpp
             ../utils/guiproxy.cpp
             ../utils/cursorsaver.cpp
             ../fieldformat.cpp
             ../tellico_debug.cpp
    TEST_NAME imagetest
    LINK_LIBRARIES Qt${QT_MAJOR_VERSION}::Test KF${KF_MAJOR_VERSION}::Archive images
)

ecm_add_test(imagejobtest.cpp ../fieldformat.cpp ../tellico_debug.cpp
    TEST_NAME imagejobtest
    LINK_LIBRARIES Qt${QT_MAJOR_VERSION}::Test  KF${KF_MAJOR_VERSION}::Archive images
)

ecm_add_test(iso6937test.cpp ../tellico_debug.cpp
    TEST_NAME iso6937test
    LINK_LIBRARIES Qt${QT_MAJOR_VERSION}::Test utils
)

ecm_add_test(iso5426test.cpp ../tellico_debug.cpp
    TEST_NAME iso5426test
    LINK_LIBRARIES Qt${QT_MAJOR_VERSION}::Test utils
)

ecm_add_test(newstufftest.cpp ../fieldformat.cpp ../tellico_debug.cpp
    TEST_NAME newstufftest
    LINK_LIBRARIES Qt${QT_MAJOR_VERSION}::Test newstuff config
)

ecm_add_test(rtftest.cpp
    TEST_NAME rtftest
    LINK_LIBRARIES Qt${QT_MAJOR_VERSION}::Test rtf2html-tellico
)

set(tellicotest_SRCS
    ../collection.cpp
    ../entry.cpp
    ../entrygroup.cpp
    ../entrycomparison.cpp
    ../field.cpp
    ../fieldformat.cpp
    ../filter.cpp
    ../borrower.cpp
    ../collectionfactory.cpp
    ../derivedvalue.cpp
    ../progressmanager.cpp
    ../tellico_debug.cpp
)

add_library(tellicotest STATIC ${tellicotest_SRCS})
target_link_libraries(tellicotest Qt${QT_MAJOR_VERSION}::Core Qt${QT_MAJOR_VERSION}::Gui KF${KF_MAJOR_VERSION}::I18n KF${KF_MAJOR_VERSION}::ConfigWidgets)

add_dependencies(tellicotest tellico_config)

set(translatorstest_SRCS
    ../translators/tellicoimporter.cpp
    ../translators/xsltimporter.cpp
    ../translators/textimporter.cpp
    ../translators/dataimporter.cpp
    ../translators/importer.cpp
    ../translators/tellicoxmlreader.cpp
    ../translators/tellico_xml.cpp
    ../translators/xmlstatehandler.cpp
    ../translators/xslthandler.cpp
)

add_library(translatorstest STATIC ${translatorstest_SRCS})
target_link_libraries(translatorstest
    Qt${QT_MAJOR_VERSION}::Core
    Qt${QT_MAJOR_VERSION}::Gui
    Qt${QT_MAJOR_VERSION}::Widgets
    Qt${QT_MAJOR_VERSION}::Xml
    KF${KF_MAJOR_VERSION}::I18n
    KF${KF_MAJOR_VERSION}::Archive
    KF${KF_MAJOR_VERSION}::KIOWidgets
    KF${KF_MAJOR_VERSION}::ConfigWidgets
    ${LIBXML2_LIBRARIES}
    ${LIBXSLT_LIBRARIES}
    ${LIBXSLT_EXSLT_LIBRARIES}
)

set(TELLICO_TEST_LIBS
    tellicotest
    collections
    utils
    images
    core
    tellicomodels
    Qt${QT_MAJOR_VERSION}::Test
    KF${KF_MAJOR_VERSION}::KIOCore
    KF${KF_MAJOR_VERSION}::Archive
)

ecm_add_test(collectiontest.cpp
             ../document.cpp
             ../utils/mergeconflictresolver.cpp
             ../translators/tellicoxmlexporter.cpp
             ../translators/tellicozipexporter.cpp
             ../translators/exporter.cpp
    TEST_NAME collectiontest
    LINK_LIBRARIES ${TELLICO_TEST_LIBS} translatorstest
)

ecm_add_test(commandtest.cpp
             ../commands/collectioncommand.cpp
             ../document.cpp
             ../translators/tellicoxmlexporter.cpp
             ../translators/tellicozipexporter.cpp
             ../translators/exporter.cpp
    TEST_NAME commandtest
    LINK_LIBRARIES translatorstest ${TELLICO_TEST_LIBS}
    # order of library linking here apparently matters
)

ecm_add_test(documenttest.cpp
             ../document.cpp
             ../translators/tellicoxmlexporter.cpp
             ../translators/tellicozipexporter.cpp
             ../translators/exporter.cpp
    TEST_NAME documenttest
    LINK_LIBRARIES ${TELLICO_TEST_LIBS} translatorstest
)

ecm_add_test(entrycomparisontest.cpp
    TEST_NAME entrycomparisontest
    LINK_LIBRARIES ${TELLICO_TEST_LIBS}
)

ecm_add_test(filtertest.cpp
             ../filter.cpp
             ../filterparser.cpp
    TEST_NAME filtertest
    LINK_LIBRARIES ${TELLICO_TEST_LIBS}
)

ecm_add_test(tellicomodeltest.cpp
             modeltest.cpp
             ../document.cpp
             ../translators/tellicoimporter.cpp
             ../translators/dataimporter.cpp
             ../translators/importer.cpp
             ../translators/tellicoxmlexporter.cpp
             ../translators/tellicozipexporter.cpp
             ../translators/exporter.cpp
             ../translators/tellicoxmlreader.cpp
             ../translators/tellico_xml.cpp
             ../translators/xmlstatehandler.cpp
    TEST_NAME tellicomodeltest
    LINK_LIBRARIES ${TELLICO_TEST_LIBS} ${LIBXML2_LIBRARIES}
)

######################################################

ecm_add_test(adstest.cpp
             ../translators/adsimporter.cpp
             ../translators/importer.cpp
    TEST_NAME adstest
    LINK_LIBRARIES ${TELLICO_TEST_LIBS}
)

ecm_add_test(alexandriatest.cpp
             ../translators/alexandriaimporter.cpp
             ../translators/importer.cpp
             ../translators/alexandriaexporter.cpp
             ../translators/exporter.cpp
    TEST_NAME alexandriatest
    LINK_LIBRARIES ${TELLICO_TEST_LIBS}
)

ecm_add_test(amctest.cpp
             ../translators/amcimporter.cpp
             ../translators/dataimporter.cpp
             ../translators/importer.cpp
    TEST_NAME amctest
    LINK_LIBRARIES ${TELLICO_TEST_LIBS}
)

if(TAGLIB_FOUND)
  ecm_add_test(audiofiletest.cpp
               ../translators/audiofileimporter.cpp
               ../translators/dataimporter.cpp
               ../translators/importer.cpp
      TEST_NAME audiofiletest
      LINK_LIBRARIES ${TELLICO_TEST_LIBS} ${TAGLIB_LIBRARIES}
  )
endif(TAGLIB_FOUND)

ecm_add_test(bibtextest.cpp
             ../translators/bibteximporter.cpp
             ../translators/importer.cpp
             ../translators/bibtexexporter.cpp
             ../translators/exporter.cpp
    TEST_NAME bibtextest
    LINK_LIBRARIES ${TELLICO_TEST_LIBS} ${TELLICO_BTPARSE_LIBS}
)

ecm_add_test(bibtexmltest.cpp
             ../translators/bibtexmlimporter.cpp
             ../translators/bibtexmlexporter.cpp
             ../translators/exporter.cpp
    TEST_NAME bibtexmltest
    LINK_LIBRARIES ${TELLICO_TEST_LIBS} translatorstest core
)

ecm_add_test(citetest.cpp
             ../collections/bibtexcollection.cpp
             ../core/filehandler.cpp
    TEST_NAME citetest
    LINK_LIBRARIES Qt${QT_MAJOR_VERSION}::Test cite tellicotest config images
)

ecm_add_test(ciwtest.cpp
             ../translators/ciwimporter.cpp
             ../translators/importer.cpp
    TEST_NAME ciwtest
    LINK_LIBRARIES ${TELLICO_TEST_LIBS}
)

ecm_add_test(collectorztest.cpp
             ../translators/collectorzimporter.cpp
    TEST_NAME collectorztest
    LINK_LIBRARIES ${TELLICO_TEST_LIBS} translatorstest
)

ecm_add_test(csvtest.cpp
             ../translators/csvparser.cpp
             ../translators/csvimporter.cpp
             ../translators/csvexporter.cpp
             ../translators/exporter.cpp
             ../gui/collectiontypecombo.cpp
             ../gui/combobox.cpp
             ../gui/listwidgetitem.cpp
             ../gui/stringmapwidget.cpp
             ../gui/stringmapdialog.cpp
             ../collectionfieldsdialog.cpp
    TEST_NAME csvtest
    LINK_LIBRARIES ${TELLICO_CSV_LIBS} ${TELLICO_TEST_LIBS} translatorstest
)

ecm_add_test(datacrowtest.cpp
             ../translators/datacrowimporter.cpp
    TEST_NAME datacrowtest
    LINK_LIBRARIES ${TELLICO_TEST_LIBS} translatorstest
)

ecm_add_test(delicioustest.cpp
             ../translators/deliciousimporter.cpp
    TEST_NAME delicioustest
    LINK_LIBRARIES ${TELLICO_TEST_LIBS} translatorstest rtf2html-tellico
)

ecm_add_test(discogstest.cpp
             ../translators/discogsimporter.cpp
    TEST_NAME discogstest
    LINK_LIBRARIES ${TELLICO_TEST_LIBS} translatorstest
)

ecm_add_test(fieldwidgettest.cpp
             ../gui/boolfieldwidget.cpp
             ../gui/checkablecombobox.cpp
             ../gui/choicefieldwidget.cpp
             ../gui/datefieldwidget.cpp
             ../gui/datewidget.cpp
             ../gui/spinbox.cpp
             ../gui/linefieldwidget.cpp
             ../gui/lineedit.cpp
             ../gui/numberfieldwidget.cpp
             ../gui/parafieldwidget.cpp
             ../gui/ratingwidget.cpp
             ../gui/ratingfieldwidget.cpp
             ../gui/tablefieldwidget.cpp
             ../gui/urlfieldwidget.cpp
             ../gui/fieldwidget.cpp
             ../document.cpp
             ../fieldcompletion.cpp
             ../translators/tellicoxmlexporter.cpp
             ../translators/tellicozipexporter.cpp
             ../translators/exporter.cpp
    TEST_NAME fieldwidgettest
    LINK_LIBRARIES translatorstest ${TELLICO_TEST_LIBS} KF${KF_MAJOR_VERSION}::XmlGui KF${KF_MAJOR_VERSION}::SonnetCore KF${KF_MAJOR_VERSION}::SonnetUi KF${KF_MAJOR_VERSION}::TextWidgets
)

ecm_add_test(filelistingtest.cpp
             ../translators/filelistingimporter.cpp
             ../translators/filereader.cpp
             ../translators/filereaderbook.cpp
             ../translators/filereadervideo.cpp
             ../translators/xmphandler.cpp
             ../gui/collectiontypecombo.cpp
             ../gui/combobox.cpp
    TEST_NAME filelistingtest
    LINK_LIBRARIES translatorstest ${TELLICO_TEST_LIBS} KF${KF_MAJOR_VERSION}::Solid #order of libs here is important
)
if(KF${KF_MAJOR_VERSION}FileMetaData_FOUND)
  target_link_libraries(filelistingtest KF${KF_MAJOR_VERSION}::FileMetaData)
endif(KF${KF_MAJOR_VERSION}FileMetaData_FOUND)
if(Exempi_FOUND)
  target_link_libraries(filelistingtest ${Exempi_LIBRARIES})
endif(Exempi_FOUND)

ecm_add_test(gcstartest.cpp
             ../translators/gcstarimporter.cpp
             ../translators/gcstarexporter.cpp
             ../translators/tellicoxmlexporter.cpp
             ../translators/tellicozipexporter.cpp
             ../translators/exporter.cpp
             ../document.cpp
    TEST_NAME gcstartest
    LINK_LIBRARIES ${TELLICO_TEST_LIBS} translatorstest
)

ecm_add_test(goodreadstest.cpp
             ../translators/goodreadsimporter.cpp
    TEST_NAME goodreadstest
    LINK_LIBRARIES ${TELLICO_TEST_LIBS} translatorstest
)

ecm_add_test(griffithtest.cpp
             ../translators/griffithimporter.cpp
    TEST_NAME griffithtest
    LINK_LIBRARIES ${TELLICO_TEST_LIBS} translatorstest
)

ecm_add_test(htmlexportertest.cpp
             ../translators/htmlexporter.cpp
             ../translators/tellicoxmlexporter.cpp
             ../translators/tellicozipexporter.cpp
             ../translators/exporter.cpp
             ../document.cpp
