=== debian/changelog ===
tellico (4.0-1) unstable; urgency=medium

  * New upstream release.
  * Update the build dependencies according to the upstream build system:
    - bump Qt packages to 5.12.0
    - bump KF packages to 5.72.0
    - add libkf5completion-dev, explicitly searched
    - add breeze-icon-theme for FileListingTest, which tries to load a MIME icon
    - drop libkf5wallet-dev, no more used
  * Pass -DBUILD_WITH_QT6=OFF to cmake to keep building with Qt5/KF5 for now.
  * Update the patches:
    - tests-disable-fetchertest.diff: refresh
  * Drop duplicate commas in the Build-Depends control field: it looks like
    newer versions of apt fail to parse them.
  * CI: make the build non-verbose, so the build log fits within the salsa
    limits.
  * Update install files.

 -- Pino Toscano <pino@debian.org>  Sun, 08 Sep 2024 08:25:49 +0200
